// bezier07View.h : interface of the CBezierView class
//
/////////////////////////////////////////////////////////////////////////////

enum MODE {VIEW, EDIT, ADD, DEL};

class CBezierView : public CScrollView
{
protected: // create from serialization only
	CBezierView();
	DECLARE_DYNCREATE(CBezierView)

// Attributes
public:
	CBezierDoc* GetDocument();
	CRect rect;
	char r,g,b;
	//CBezier* curve;
	BOOL m_bCaptured;

// Operations
public:
	CBezier* GetBezier() {
		return GetDocument()->GetBezier();
	}

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBezierView)
	public:
	virtual void OnInitialUpdate();
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBezierView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CBezierView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnEditPoint();
	afx_msg void OnAddPoint();
	afx_msg void OnDelPoint();
	afx_msg void OnViewCurve();
	afx_msg void OnUpdateAddPoint(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDelPoint(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditPoint(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewCurve(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in bezier07View.cpp
inline CBezierDoc* CBezierView::GetDocument()
   { return (CBezierDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
