class CDib : public CObject
{
	enum Ubicacion {NO_UBIC, CRT_HEAP, GLOBAL_HEAP};
    DECLARE_SERIAL(CDib)

	BITMAPINFO* m_pBMI;
	BYTE* m_pBits;

	Ubicacion m_nUbicBMI;
    Ubicacion m_nUbicBits;

	HPALETTE m_hPaleta;
	HBITMAP m_hSeccion;
    HGLOBAL m_hGlobal;

    HANDLE m_hFile;
    HANDLE m_hMap;
    LPVOID m_lpvFile;

	BYTE m_IndiceTrans;

	int m_nMaxFila; /*=alto -1*/
	int m_nMaxColumna; /*=ancho renglon*/

public:
	void Crear(const CDib& bmp);
    CDib();
    ~CDib();
    
	BOOL Crear(int ancho, int alto, int bpp);
	inline BOOL Crear(const CSize& dim, int bpp);
	HBITMAP CrearSeccion(CSize dim, int bpp, CDC* pDC);
	BOOL Mapear(const char* path, BOOL compartir = FALSE);
	BOOL Cargar(const char* path, UINT nOpenFlags = CFile::modeRead);
	BOOL Cargar(CFile *pFile);
	void EngancharMemoria(void* pvMem, BOOL eliminar = FALSE, HGLOBAL hGlobal = FALSE);

	BOOL CopiarBits();
	BOOL CopiarAMapFile(const char* path);
	BOOL Copiar(CFile* pFile);
	void Serialize(CArchive& ar);

	BOOL AsgPaleta();
	BOOL AsgPaletaDelSistema(CDC* pDC);

	int Ancho() const { return m_pBMI->bmiHeader.biWidth; }
	int Alto() const { return m_pBMI->bmiHeader.biHeight; }
	int AnchoRenglon() const { return (m_pBMI->bmiHeader.biWidth + 3) & ~3; }

	int ObtDimPaleta(int nBitCount = 0);
	CSize ObtDim();
	DWORD ObtDimBits();
	int ObtBitsPorPixel();

	void Vaciar();
	BOOL EstaVacio() {return (m_pBits) ? FALSE:TRUE;}
	BOOL CrearBMI(int ancho, int alto, int bpp);
	BOOL Dibujar(CDC* pDC, CPoint origin, CSize size);

	BYTE& ObtPixel(int y, int x) {
		ASSERT(m_pBMI->bmiHeader.biBitCount == 8);				// This version deals only with 8 bpp DIBs.
		ASSERT(x < Ancho() && y < Alto());						// Make sure it's in range and if it isn't return zero.
		return *(m_pBits + (Alto()-y-1) * AnchoRenglon() + x);	// AnchoRenglon() Calculates the scan line storage width.
	}

	BYTE* operator[](int i) {
		return (m_pBits + (m_nMaxFila - i) * m_nMaxColumna);
		//return (m_pBits + (Alto()-i-1) * AnchoRenglon());
	}

#ifdef _DEBUG
    virtual void Dump( CDumpContext& dc ) const;
#endif
};

/*class CDibPal : public CPalette
{
public:
    CDibPal();

    ~CDibPal();

    //BOOL Create(CDib* pDIB);            // Create from a DIB.
	BOOL Crear(CDib* pDIB);            // Crear desde un DIB.

    //int GetNumColors();                 // Obtener la cantidad de colores.
	int ObtCantColores();                 // Obtener la cantidad de colores.

    //void Draw(CDC* pDC, CRect* pRect, BOOL bBkgnd = FALSE); 
	//void Dibujar(CDC* pDC, CRect* pRect, BOOL bBkgnd = FALSE); 

    //BOOL SetSysPalColors();
	BOOL MapearPalSist();
};*/