#define WM_DETECTION_STATUS WM_USER + 6

class CEdgeDetector : public CObject
{
	int m_nRows, m_nCols;
	HWND m_hWnd;

protected:
	DECLARE_DYNAMIC(CEdgeDetector)
	
	float** f2d () const;
	void Free_f2d(float** p) const {
		for (int i = 0; i < m_nRows; i++) 
			free(p[i]);
		free(p);
	}

	int GetRows() const {return m_nRows;}
	int GetCols() const {return m_nCols;}
	void SetRows(int rows) {m_nRows = rows;}
	void SetCols(int cols) {m_nCols = cols;}
	
	LRESULT SetProgress(UINT pos, LPCTSTR str = NULL) const {
		if (m_hWnd)
			return ::SendMessage(m_hWnd, WM_DETECTION_STATUS, 
				pos, (LPARAM) str);
		else
			return 0L;
	}

public:
	CEdgeDetector();
	virtual ~CEdgeDetector();
	virtual bool Detect(CImage& src) = 0;
	virtual char* GetName() = 0;
	virtual void GetParams(CString& params) = 0;
	void SetMessageWnd(HWND hWnd) {m_hWnd = hWnd;}
};
