// ImageView.cpp : implementation file
//

#include "stdafx.h"
#include "SRAF.h"
#include <afxcview.h>
#include "ImageView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CImageView

IMPLEMENT_DYNCREATE(CImageView, CTreeView)

CImageView::CImageView()
{
}

CImageView::~CImageView()
{
}


BEGIN_MESSAGE_MAP(CImageView, CTreeView)
	//{{AFX_MSG_MAP(CImageView)
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnDblclk)
	ON_UPDATE_COMMAND_UI(ID_ADD_POINT, OnUpdateAddPoint)
	ON_UPDATE_COMMAND_UI(ID_DEL_POINT, OnUpdateDelPoint)
	ON_UPDATE_COMMAND_UI(ID_EDIT_POINT, OnUpdateEditPoint)
	ON_UPDATE_COMMAND_UI(ID_VIEW_CURVE, OnUpdateViewCurve)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CImageView drawing

void CImageView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CImageView diagnostics

#ifdef _DEBUG
void CImageView::AssertValid() const
{
	CTreeView::AssertValid();
}

void CImageView::Dump(CDumpContext& dc) const
{
	CTreeView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CImageView message handlers

void CImageView::OnInitialUpdate() 
{
	CTreeView::OnInitialUpdate();

	m_imageList.Create(16, 16, 0, 2, 10);	//size, size, flag, initial number, max number

	m_imageList.Add(AfxGetApp()->LoadIcon(IDI_CLOSED_FOLDER));
	m_imageList.Add(AfxGetApp()->LoadIcon(IDI_IMG_ITEM));
	
	GetTreeCtrl().SetImageList(&m_imageList, TVSIL_NORMAL);

	HTREEITEM padre;

	padre = InsertItem("Diego", 1, 0, 0);
			InsertItem("Diego2", 1, 1, 1, padre);
			InsertItem("Diego3", 1, 1, 1, padre);
	GetTreeCtrl().Expand(padre, TVE_EXPAND);
	padre = InsertItem("Diego4", 1, 0, 0);
			InsertItem("Diego5", 1, 1, 1, padre);
	GetTreeCtrl().Expand(padre, TVE_EXPAND);
			InsertItem("Diego6", 1, 0, 0);

}

HTREEITEM CImageView::InsertItem(CString texto, LPARAM parametro,
	int imagen, int seleccion, HTREEITEM hPadre, HTREEITEM hAnterior)
{
	TV_INSERTSTRUCT m_tvinsert;	

	// Campos comunes.
	m_tvinsert.item.mask = TVIF_IMAGE | TVIF_SELECTEDIMAGE | 
		TVIF_TEXT | TVIF_PARAM;
	m_tvinsert.item.hItem = NULL;
	m_tvinsert.item.state = 0;
	m_tvinsert.item.stateMask = 0;
	m_tvinsert.item.cchTextMax = 6;
	m_tvinsert.item.cChildren = 0;
	// fin campos comunes

	m_tvinsert.hParent = hPadre;
	m_tvinsert.hInsertAfter = hAnterior;
	m_tvinsert.item.pszText = texto.GetBuffer(0);
	m_tvinsert.item.lParam = parametro;
	m_tvinsert.item.iImage = imagen;
	m_tvinsert.item.iSelectedImage = seleccion;

	return GetTreeCtrl().InsertItem(&m_tvinsert);
}

void CImageView::OnDblclk(NMHDR* pNMHDR, LRESULT* pResult) 
{
	AfxMessageBox("Dblclick");
	
	*pResult = 0;
}

void CImageView::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CTreeView::OnPrepareDC(pDC, pInfo);
}

void CImageView::OnUpdateAddPoint(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CImageView::OnUpdateDelPoint(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CImageView::OnUpdateEditPoint(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CImageView::OnUpdateViewCurve(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}
