// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__04584F6A_91D4_11D1_A62F_AAA07E000000__INCLUDED_)
#define AFX_MAINFRM_H__04584F6A_91D4_11D1_A62F_AAA07E000000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CMainFrame : public CMDIFrameWnd
{
	DECLARE_DYNAMIC(CMainFrame)
public:
	CMainFrame();

private:
	/* para guardar el estado en los registros */
	static const CRect s_rectDefault;
	static const char s_profileHeading[];
	static const char s_profileRect[];
	static const char s_profileIcon[];
	static const char s_profileMax[];
	static const char s_profileTool[];
	static const char s_profileStatus[];
	/* --------------------------------------- */

// Attributes
public:
	CImageBar m_wndImgBar;
	CToolBar m_wndDrawBar;
	int m_nChildFrame;

// Operations
public:
	CImageBar* GetImageBar() {return &m_wndImgBar;}

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	CBezierDoc* FindBezierDoc(long lID);
	int GetSavedState(int);
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnNewGroup();
	afx_msg void OnAddItem();
	afx_msg void OnDelItem();
	afx_msg void OnUpdateVerImageBar(CCmdUI* pCmdUI);
	afx_msg void OnVerImageBar();
	afx_msg void OnDestroy();
	afx_msg void OnVerDrawingbar();
	afx_msg void OnUpdateVerDrawingbar(CCmdUI* pCmdUI);
	//}}AFX_MSG
	afx_msg void OnDblclk(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnEditItem(LPNMHDR pnmhdr, LRESULT *pLResult);
	afx_msg void OnHideDrawBar(WPARAM wParam, LPARAM lParam);
	afx_msg void OnKeydownTree(NMHDR* pNMHDR, LRESULT* pResult);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__04584F6A_91D4_11D1_A62F_AAA07E000000__INCLUDED_)
