// SRAF.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"

#include "SRAF.h"

#include "ChildFrm.h"
#include "Image.h"
#include "EdgeDetector.h"
#include "Canny.h"
#include "Shen.h"
#include "SRAFDoc.h"
#include "SRAFView.h"
#include <afxcview.h>
#include "ImageFrame.h"
#include "ImageDoc.h"
//#include "ImageView.h"
#include "Bezier.h"
#include "BezierFrame.h"
#include "BezierSet.h"
#include "BezierDoc.h"
#include "BezierView.h"
#include "ImageBar.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSRAFApp

BEGIN_MESSAGE_MAP(CSRAFApp, CWinApp)
	//{{AFX_MSG_MAP(CSRAFApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_IMAGE_VIEW, OnImageView)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSRAFApp construction

CSRAFApp::CSRAFApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CSRAFApp object

CSRAFApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CSRAFApp initialization

BOOL CSRAFApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	SetRegistryKey("SRAF");
	LoadStdProfileSettings(0);  // Load standard INI file options (including MRU)

	//set the default DB path
	int len = strlen(m_pszHelpFilePath);
	m_pszDBPath = new char[len + 1];
	strcpy(m_pszDBPath, m_pszHelpFilePath);
	strcpy(m_pszDBPath + len - 3, "mdb");
	/////////////////////////////////////
	
	CDialog* pDlg = new CDialog;
	pDlg->Create(IDD_PRESENTATION);
	
	// Register document templates

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_SRAFTYPE,
		RUNTIME_CLASS(CSRAFDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CSRAFView));
	AddDocTemplate(pDocTemplate);

	AddDocTemplate(new CMultiDocTemplate(
		IDR_BEZIERTYPE,
		RUNTIME_CLASS(CBezierDoc),
		RUNTIME_CLASS(CBezierFrame), // custom MDI child frame
		RUNTIME_CLASS(CBezierView)));

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	/*// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;*/
	m_nCmdShow = pMainFrame->GetSavedState(m_nCmdShow);
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	pDlg->DestroyWindow();
	delete pDlg;

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CSRAFApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CSRAFApp commands

int CSRAFApp::ExitInstance() 
{	
	return CWinApp::ExitInstance();
}

void CSRAFApp::OnImageView() 
{
	POSITION curTemplatePos = GetFirstDocTemplatePosition();

	while(curTemplatePos != NULL)
	{
		CDocTemplate* curTemplate = 
			GetNextDocTemplate(curTemplatePos);
		CString str;
		curTemplate->GetDocString(str, CDocTemplate::docName);
		if(str == _T("Diccionario"))
		{
			curTemplate->OpenDocumentFile(NULL);
			return;
		}
	}
	AfxMessageBox("Error en el template");	
}

