// SRAFDoc.h : interface of the CSRAFDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SRAFDOC_H__04584F6E_91D4_11D1_A62F_AAA07E000000__INCLUDED_)
#define AFX_SRAFDOC_H__04584F6E_91D4_11D1_A62F_AAA07E000000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CSRAFDoc : public CDocument
{
	enum EDGE_DETECTOR {SHEN, CANNY};
	static CCanny m_canny;
	static CShen m_shen;
	static EDGE_DETECTOR m_detector;

protected: // create from serialization only
	CSRAFDoc();
	DECLARE_DYNCREATE(CSRAFDoc)

// Attributes
public:
	CDib m_dib;

// Operations
public:
	CEdgeDetector* CreateEdgeDetector() {
		if (m_detector == SHEN) 
			//return &m_shen;
			return new CShen(m_shen);
		else 
			//return &m_canny;
			return new CCanny(m_canny);
	}
	void DestroyEdgeDetector(CEdgeDetector* p) {
		delete p;
	}

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSRAFDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CSRAFDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CSRAFDoc)
	afx_msg void OnOptions();
	afx_msg void OnReloadImage();
	afx_msg void OnUpdateReloadImage(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SRAFDOC_H__04584F6E_91D4_11D1_A62F_AAA07E000000__INCLUDED_)
