// SRAFView.h : interface of the CSRAFView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SRAFVIEW_H__04584F70_91D4_11D1_A62F_AAA07E000000__INCLUDED_)
#define AFX_SRAFVIEW_H__04584F70_91D4_11D1_A62F_AAA07E000000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "ProgressDlg.h"
#include "ResultDlg.h"

class CSrafContext {
public:
	CImage m_image;
	CEdgeDetector* m_pDetector;	//it should be stored in the heap
	HWND m_hWnd;
	
	CSrafContext() {
		m_image = NULL;
		m_pDetector = NULL;
		m_hWnd = NULL;
	}
};

class CSRAFView : public CScrollView
{
protected: // create from serialization only
	CSRAFView();
	DECLARE_DYNCREATE(CSRAFView)

// Attributes
public:
	CSRAFDoc* GetDocument();
	void ShowResult(CPoint point, CString nombre, float area, float perimetro);

// Operations
public:
	static bool m_bShowProgressDlg;
	CSrafContext* m_pContext;
	CProgressDlg m_dlg;
	CResultDlg* m_pResultDlg;
	CStringList m_imgList;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSRAFView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CSRAFView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CSRAFView)
	afx_msg void OnStartRecognize();
	afx_msg void OnProgressDlg();
	afx_msg void OnUpdateProgressDlg(CCmdUI* pCmdUI);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG
	afx_msg LRESULT OnEndRecognize(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in SRAFView.cpp
inline CSRAFDoc* CSRAFView::GetDocument()
   { return (CSRAFDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SRAFVIEW_H__04584F70_91D4_11D1_A62F_AAA07E000000__INCLUDED_)
