#include "StdAfx.h"
#include "Image.h"
#include "Tracer.h"

//#define BLACK 0
//#define WHITE 255
#define RED 1
#define BLUE 2
#define GREEN 3
#define YELLOW 4

void CTracer::Trace(CImage& img)
{
	int row, col, pr, pc, cr, cc;
	int i = 0;

	for (row = 0; row < img.GetRows(); row++) {
		for (col = 0; col < img.GetCols(); col++) {
			if (img[row][col] == BLACK && i < 8) {
				i++;
				pr = cr = row;
				pc = cc = col;
				while ( ( GetNext(img, pr, pc, cr, cc) || MakeBridge(img, pr, pc, cr, cc) ) 
					&& (cr != row || cc != col) ) 
				{
					img[cr][cc] = BLUE;
				}
				if ((cr == row) && (cc == col)) 
				{
					img[cr][cc] = RED;
				}
				else {
					img[cr][cc] = YELLOW;
				}
			}
		}
	}
}

bool CTracer::GetNext(CImage& img, int& pr, int& pc, int& cr, int& cc)
{
	int row, col, maxrow, mincol, maxcol;

	row = (cr > 0) ? cr - 1:0;
	maxrow = (cr < img.GetRows() - 1) ? cr + 1:img.GetRows() - 1;

	mincol = (cc > 0) ? cc - 1:0;
	maxcol = (cc < img.GetCols() - 1) ? cc + 1:img.GetCols() - 1;

	for (; row <= maxrow; row++)
		for (col = mincol; col <= maxcol; col++)
			if ((row != pr || col != pc) &&
				(row != cr || col != cc) &&
				(img[row][col] == BLACK))
			{
				pr = cr;
				pc = cc;
				cr = row;
				cc = col;
				return true;
			}

	return false;
}

bool CTracer::MakeBridge(CImage& img, int& pr, int& pc, int& cr, int& cc)
{
	return false;
}
